t5000, t5003: do not use test_cmp to compare binary files
[git/git.git] / t / test-lib-functions.sh
CommitLineData
c74c7203
JN
1# Library of functions shared by all tests scripts, included by
2# test-lib.sh.
12a29b1a
TR
3#
4# Copyright (c) 2005 Junio C Hamano
5#
6# This program is free software: you can redistribute it and/or modify
7# it under the terms of the GNU General Public License as published by
8# the Free Software Foundation, either version 2 of the License, or
9# (at your option) any later version.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
16# You should have received a copy of the GNU General Public License
17# along with this program. If not, see http://www.gnu.org/licenses/ .
18
19# The semantics of the editor variables are that of invoking
20# sh -c "$EDITOR \"$@\"" files ...
21#
22# If our trash directory contains shell metacharacters, they will be
23# interpreted if we just set $EDITOR directly, so do a little dance with
24# environment variables to work around this.
25#
26# In particular, quoting isn't enough, as the path may contain the same quote
27# that we're using.
28test_set_editor () {
29 FAKE_EDITOR="$1"
30 export FAKE_EDITOR
31 EDITOR='"$FAKE_EDITOR"'
32 export EDITOR
33}
34
5d9fc888
TG
35test_set_index_version () {
36 GIT_INDEX_VERSION="$1"
37 export GIT_INDEX_VERSION
38}
39
12a29b1a
TR
40test_decode_color () {
41 awk '
42 function name(n) {
43 if (n == 0) return "RESET";
44 if (n == 1) return "BOLD";
45 if (n == 30) return "BLACK";
46 if (n == 31) return "RED";
47 if (n == 32) return "GREEN";
48 if (n == 33) return "YELLOW";
49 if (n == 34) return "BLUE";
50 if (n == 35) return "MAGENTA";
51 if (n == 36) return "CYAN";
52 if (n == 37) return "WHITE";
53 if (n == 40) return "BLACK";
54 if (n == 41) return "BRED";
55 if (n == 42) return "BGREEN";
56 if (n == 43) return "BYELLOW";
57 if (n == 44) return "BBLUE";
58 if (n == 45) return "BMAGENTA";
59 if (n == 46) return "BCYAN";
60 if (n == 47) return "BWHITE";
61 }
62 {
63 while (match($0, /\033\[[0-9;]*m/) != 0) {
64 printf "%s<", substr($0, 1, RSTART-1);
65 codes = substr($0, RSTART+2, RLENGTH-3);
66 if (length(codes) == 0)
67 printf "%s", name(0)
68 else {
69 n = split(codes, ary, ";");
70 sep = "";
71 for (i = 1; i <= n; i++) {
72 printf "%s%s", sep, name(ary[i]);
73 sep = ";"
74 }
75 }
76 printf ">";
77 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
78 }
79 print
80 }
81 '
82}
83
84nul_to_q () {
94221d22 85 perl -pe 'y/\000/Q/'
12a29b1a
TR
86}
87
88q_to_nul () {
94221d22 89 perl -pe 'y/Q/\000/'
12a29b1a
TR
90}
91
92q_to_cr () {
93 tr Q '\015'
94}
95
96q_to_tab () {
97 tr Q '\011'
98}
99
250b3c6c
JH
100qz_to_tab_space () {
101 tr QZ '\011\040'
12a29b1a
TR
102}
103
104append_cr () {
105 sed -e 's/$/Q/' | tr Q '\015'
106}
107
108remove_cr () {
109 tr '\015' Q | sed -e 's/Q$//'
110}
111
112# In some bourne shell implementations, the "unset" builtin returns
113# nonzero status when a variable to be unset was not set in the first
114# place.
115#
116# Use sane_unset when that should not be considered an error.
117
118sane_unset () {
119 unset "$@"
120 return 0
121}
122
123test_tick () {
124 if test -z "${test_tick+set}"
125 then
126 test_tick=1112911993
127 else
128 test_tick=$(($test_tick + 60))
129 fi
130 GIT_COMMITTER_DATE="$test_tick -0700"
131 GIT_AUTHOR_DATE="$test_tick -0700"
132 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
133}
134
135# Stop execution and start a shell. This is useful for debugging tests and
136# only makes sense together with "-v".
137#
138# Be sure to remove all invocations of this command before submitting.
139
140test_pause () {
141 if test "$verbose" = t; then
142 "$SHELL_PATH" <&6 >&3 2>&4
143 else
144 error >&5 "test_pause requires --verbose"
145 fi
146}
147
4c994194 148# Call test_commit with the arguments "<message> [<file> [<contents> [<tag>]]]"
12a29b1a
TR
149#
150# This will commit a file with the given contents and the given commit
4c994194 151# message, and tag the resulting commit with the given tag name.
12a29b1a 152#
4c994194 153# <file>, <contents>, and <tag> all default to <message>.
12a29b1a
TR
154
155test_commit () {
9a0231b3 156 notick= &&
5ed75e2a
MV
157 signoff= &&
158 while test $# != 0
159 do
160 case "$1" in
161 --notick)
162 notick=yes
163 ;;
164 --signoff)
165 signoff="$1"
166 ;;
167 *)
168 break
169 ;;
170 esac
9a0231b3 171 shift
5ed75e2a 172 done &&
9a0231b3 173 file=${2:-"$1.t"} &&
12a29b1a
TR
174 echo "${3-$1}" > "$file" &&
175 git add "$file" &&
9a0231b3
JH
176 if test -z "$notick"
177 then
178 test_tick
179 fi &&
5ed75e2a 180 git commit $signoff -m "$1" &&
4c994194 181 git tag "${4:-$1}"
12a29b1a
TR
182}
183
184# Call test_merge with the arguments "<message> <commit>", where <commit>
185# can be a tag pointing to the commit-to-merge.
186
187test_merge () {
188 test_tick &&
189 git merge -m "$1" "$2" &&
190 git tag "$1"
191}
192
193# This function helps systems where core.filemode=false is set.
194# Use it instead of plain 'chmod +x' to set or unset the executable bit
195# of a file in the working directory and add it to the index.
196
197test_chmod () {
198 chmod "$@" &&
199 git update-index --add "--chmod=$@"
200}
201
202# Unset a configuration variable, but don't fail if it doesn't exist.
203test_unconfig () {
204 git config --unset-all "$@"
205 config_status=$?
206 case "$config_status" in
207 5) # ok, nothing to unset
208 config_status=0
209 ;;
210 esac
211 return $config_status
212}
213
214# Set git config, automatically unsetting it after the test is over.
215test_config () {
216 test_when_finished "test_unconfig '$1'" &&
217 git config "$@"
218}
219
220test_config_global () {
221 test_when_finished "test_unconfig --global '$1'" &&
222 git config --global "$@"
223}
224
225write_script () {
226 {
227 echo "#!${2-"$SHELL_PATH"}" &&
228 cat
229 } >"$1" &&
230 chmod +x "$1"
231}
232
233# Use test_set_prereq to tell that a particular prerequisite is available.
234# The prerequisite can later be checked for in two ways:
235#
236# - Explicitly using test_have_prereq.
237#
238# - Implicitly by specifying the prerequisite tag in the calls to
239# test_expect_{success,failure,code}.
240#
241# The single parameter is the prerequisite tag (a simple word, in all
242# capital letters by convention).
243
244test_set_prereq () {
f3cfc3b2 245 satisfied_prereq="$satisfied_prereq$1 "
12a29b1a 246}
f3cfc3b2 247satisfied_prereq=" "
04083f27
JH
248lazily_testable_prereq= lazily_tested_prereq=
249
250# Usage: test_lazy_prereq PREREQ 'script'
251test_lazy_prereq () {
252 lazily_testable_prereq="$lazily_testable_prereq$1 "
253 eval test_prereq_lazily_$1=\$2
254}
255
256test_run_lazy_prereq_ () {
257 script='
258mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
259(
260 cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
261)'
262 say >&3 "checking prerequisite: $1"
263 say >&3 "$script"
264 test_eval_ "$script"
265 eval_ret=$?
266 rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
267 if test "$eval_ret" = 0; then
268 say >&3 "prerequisite $1 ok"
269 else
270 say >&3 "prerequisite $1 not satisfied"
271 fi
272 return $eval_ret
273}
12a29b1a
TR
274
275test_have_prereq () {
276 # prerequisites can be concatenated with ','
277 save_IFS=$IFS
278 IFS=,
279 set -- $*
280 IFS=$save_IFS
281
282 total_prereq=0
283 ok_prereq=0
284 missing_prereq=
285
286 for prerequisite
287 do
bdccd3c1
JK
288 case "$prerequisite" in
289 !*)
290 negative_prereq=t
291 prerequisite=${prerequisite#!}
292 ;;
293 *)
294 negative_prereq=
295 esac
296
04083f27
JH
297 case " $lazily_tested_prereq " in
298 *" $prerequisite "*)
299 ;;
300 *)
301 case " $lazily_testable_prereq " in
302 *" $prerequisite "*)
303 eval "script=\$test_prereq_lazily_$prerequisite" &&
304 if test_run_lazy_prereq_ "$prerequisite" "$script"
305 then
306 test_set_prereq $prerequisite
307 fi
308 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
309 esac
310 ;;
311 esac
312
12a29b1a 313 total_prereq=$(($total_prereq + 1))
f3cfc3b2 314 case "$satisfied_prereq" in
12a29b1a 315 *" $prerequisite "*)
bdccd3c1
JK
316 satisfied_this_prereq=t
317 ;;
318 *)
319 satisfied_this_prereq=
320 esac
321
322 case "$satisfied_this_prereq,$negative_prereq" in
323 t,|,t)
12a29b1a
TR
324 ok_prereq=$(($ok_prereq + 1))
325 ;;
326 *)
bdccd3c1
JK
327 # Keep a list of missing prerequisites; restore
328 # the negative marker if necessary.
329 prerequisite=${negative_prereq:+!}$prerequisite
12a29b1a
TR
330 if test -z "$missing_prereq"
331 then
332 missing_prereq=$prerequisite
333 else
334 missing_prereq="$prerequisite,$missing_prereq"
335 fi
336 esac
337 done
338
339 test $total_prereq = $ok_prereq
340}
341
342test_declared_prereq () {
343 case ",$test_prereq," in
344 *,$1,*)
345 return 0
346 ;;
347 esac
348 return 1
349}
350
351test_expect_failure () {
ae75342c 352 test_start_
12a29b1a
TR
353 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
354 test "$#" = 2 ||
355 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
356 export test_prereq
357 if ! test_skip "$@"
358 then
359 say >&3 "checking known breakage: $2"
360 if test_run_ "$2" expecting_failure
361 then
362 test_known_broken_ok_ "$1"
363 else
364 test_known_broken_failure_ "$1"
365 fi
366 fi
ae75342c 367 test_finish_
12a29b1a
TR
368}
369
370test_expect_success () {
ae75342c 371 test_start_
12a29b1a
TR
372 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
373 test "$#" = 2 ||
374 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
375 export test_prereq
376 if ! test_skip "$@"
377 then
378 say >&3 "expecting success: $2"
379 if test_run_ "$2"
380 then
381 test_ok_ "$1"
382 else
383 test_failure_ "$@"
384 fi
385 fi
ae75342c 386 test_finish_
12a29b1a
TR
387}
388
389# test_external runs external test scripts that provide continuous
390# test output about their progress, and succeeds/fails on
391# zero/non-zero exit code. It outputs the test output on stdout even
392# in non-verbose mode, and announces the external script with "# run
393# <n>: ..." before running it. When providing relative paths, keep in
394# mind that all scripts run in "trash directory".
395# Usage: test_external description command arguments...
396# Example: test_external 'Perl API' perl ../path/to/test.pl
397test_external () {
398 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
399 test "$#" = 3 ||
400 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
401 descr="$1"
402 shift
403 export test_prereq
404 if ! test_skip "$descr" "$@"
405 then
406 # Announce the script to reduce confusion about the
407 # test output that follows.
408 say_color "" "# run $test_count: $descr ($*)"
409 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
410 # to be able to use them in script
411 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
412 # Run command; redirect its stderr to &4 as in
413 # test_run_, but keep its stdout on our stdout even in
414 # non-verbose mode.
415 "$@" 2>&4
416 if [ "$?" = 0 ]
417 then
418 if test $test_external_has_tap -eq 0; then
419 test_ok_ "$descr"
420 else
421 say_color "" "# test_external test $descr was ok"
422 test_success=$(($test_success + 1))
423 fi
424 else
425 if test $test_external_has_tap -eq 0; then
426 test_failure_ "$descr" "$@"
427 else
428 say_color error "# test_external test $descr failed: $@"
429 test_failure=$(($test_failure + 1))
430 fi
431 fi
432 fi
433}
434
435# Like test_external, but in addition tests that the command generated
436# no output on stderr.
437test_external_without_stderr () {
438 # The temporary file has no (and must have no) security
439 # implications.
440 tmp=${TMPDIR:-/tmp}
441 stderr="$tmp/git-external-stderr.$$.tmp"
442 test_external "$@" 4> "$stderr"
443 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
444 descr="no stderr: $1"
445 shift
446 say >&3 "# expecting no stderr from previous command"
447 if [ ! -s "$stderr" ]; then
448 rm "$stderr"
449
450 if test $test_external_has_tap -eq 0; then
451 test_ok_ "$descr"
452 else
453 say_color "" "# test_external_without_stderr test $descr was ok"
454 test_success=$(($test_success + 1))
455 fi
456 else
457 if [ "$verbose" = t ]; then
458 output=`echo; echo "# Stderr is:"; cat "$stderr"`
459 else
460 output=
461 fi
462 # rm first in case test_failure exits.
463 rm "$stderr"
464 if test $test_external_has_tap -eq 0; then
465 test_failure_ "$descr" "$@" "$output"
466 else
467 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
468 test_failure=$(($test_failure + 1))
469 fi
470 fi
471}
472
473# debugging-friendly alternatives to "test [-f|-d|-e]"
474# The commands test the existence or non-existence of $1. $2 can be
475# given to provide a more precise diagnosis.
476test_path_is_file () {
477 if ! [ -f "$1" ]
478 then
479 echo "File $1 doesn't exist. $*"
480 false
481 fi
482}
483
484test_path_is_dir () {
485 if ! [ -d "$1" ]
486 then
487 echo "Directory $1 doesn't exist. $*"
488 false
489 fi
490}
491
492test_path_is_missing () {
493 if [ -e "$1" ]
494 then
495 echo "Path exists:"
496 ls -ld "$1"
497 if [ $# -ge 1 ]; then
498 echo "$*"
499 fi
500 false
501 fi
502}
503
504# test_line_count checks that a file has the number of lines it
505# ought to. For example:
506#
507# test_expect_success 'produce exactly one line of output' '
508# do something >output &&
509# test_line_count = 1 output
510# '
511#
512# is like "test $(wc -l <output) = 1" except that it passes the
513# output through when the number of lines is wrong.
514
515test_line_count () {
516 if test $# != 3
517 then
518 error "bug in the test script: not 3 parameters to test_line_count"
519 elif ! test $(wc -l <"$3") "$1" "$2"
520 then
521 echo "test_line_count: line count for $3 !$1 $2"
522 cat "$3"
523 return 1
524 fi
525}
526
527# This is not among top-level (test_expect_success | test_expect_failure)
528# but is a prefix that can be used in the test script, like:
529#
530# test_expect_success 'complain and die' '
531# do something &&
532# do something else &&
533# test_must_fail git checkout ../outerspace
534# '
535#
536# Writing this as "! git checkout ../outerspace" is wrong, because
537# the failure could be due to a segv. We want a controlled failure.
538
539test_must_fail () {
540 "$@"
541 exit_code=$?
542 if test $exit_code = 0; then
543 echo >&2 "test_must_fail: command succeeded: $*"
544 return 1
545 elif test $exit_code -gt 129 -a $exit_code -le 192; then
546 echo >&2 "test_must_fail: died by signal: $*"
547 return 1
548 elif test $exit_code = 127; then
549 echo >&2 "test_must_fail: command not found: $*"
550 return 1
eeb69131
TR
551 elif test $exit_code = 126; then
552 echo >&2 "test_must_fail: valgrind error: $*"
553 return 1
12a29b1a
TR
554 fi
555 return 0
556}
557
558# Similar to test_must_fail, but tolerates success, too. This is
559# meant to be used in contexts like:
560#
561# test_expect_success 'some command works without configuration' '
562# test_might_fail git config --unset all.configuration &&
563# do something
564# '
565#
566# Writing "git config --unset all.configuration || :" would be wrong,
567# because we want to notice if it fails due to segv.
568
569test_might_fail () {
570 "$@"
571 exit_code=$?
572 if test $exit_code -gt 129 -a $exit_code -le 192; then
573 echo >&2 "test_might_fail: died by signal: $*"
574 return 1
575 elif test $exit_code = 127; then
576 echo >&2 "test_might_fail: command not found: $*"
577 return 1
578 fi
579 return 0
580}
581
582# Similar to test_must_fail and test_might_fail, but check that a
583# given command exited with a given exit code. Meant to be used as:
584#
585# test_expect_success 'Merge with d/f conflicts' '
586# test_expect_code 1 git merge "merge msg" B master
587# '
588
589test_expect_code () {
590 want_code=$1
591 shift
592 "$@"
593 exit_code=$?
594 if test $exit_code = $want_code
595 then
596 return 0
597 fi
598
599 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
600 return 1
601}
602
603# test_cmp is a helper function to compare actual and expected output.
604# You can use it like:
605#
606# test_expect_success 'foo works' '
607# echo expected >expected &&
608# foo >actual &&
609# test_cmp expected actual
610# '
611#
612# This could be written as either "cmp" or "diff -u", but:
613# - cmp's output is not nearly as easy to read as diff -u
614# - not all diff versions understand "-u"
615
616test_cmp() {
617 $GIT_TEST_CMP "$@"
618}
619
b93e6e36
SK
620# test_cmp_bin - helper to compare binary files
621
622test_cmp_bin() {
623 cmp "$@"
624}
625
ca8d148d
JH
626# Check if the file expected to be empty is indeed empty, and barfs
627# otherwise.
628
629test_must_be_empty () {
630 if test -s "$1"
631 then
632 echo "'$1' is not empty, it contains:"
633 cat "$1"
634 return 1
635 fi
636}
637
5d77298d
MZ
638# Tests that its two parameters refer to the same revision
639test_cmp_rev () {
640 git rev-parse --verify "$1" >expect.rev &&
641 git rev-parse --verify "$2" >actual.rev &&
642 test_cmp expect.rev actual.rev
643}
644
d17cf5f3
MK
645# Print a sequence of numbers or letters in increasing order. This is
646# similar to GNU seq(1), but the latter might not be available
647# everywhere (and does not do letters). It may be used like:
648#
649# for i in `test_seq 100`; do
650# for j in `test_seq 10 20`; do
651# for k in `test_seq a z`; do
652# echo $i-$j-$k
653# done
654# done
655# done
656
657test_seq () {
658 case $# in
659 1) set 1 "$@" ;;
660 2) ;;
661 *) error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
662 esac
94221d22 663 perl -le 'print for $ARGV[0]..$ARGV[1]' -- "$@"
d17cf5f3
MK
664}
665
12a29b1a
TR
666# This function can be used to schedule some commands to be run
667# unconditionally at the end of the test to restore sanity:
668#
669# test_expect_success 'test core.capslock' '
670# git config core.capslock true &&
671# test_when_finished "git config --unset core.capslock" &&
672# hello world
673# '
674#
675# That would be roughly equivalent to
676#
677# test_expect_success 'test core.capslock' '
678# git config core.capslock true &&
679# hello world
680# git config --unset core.capslock
681# '
682#
683# except that the greeting and config --unset must both succeed for
684# the test to pass.
685#
686# Note that under --immediate mode, no clean-up is done to help diagnose
687# what went wrong.
688
689test_when_finished () {
690 test_cleanup="{ $*
691 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
692}
693
694# Most tests can use the created repository, but some may need to create more.
695# Usage: test_create_repo <directory>
696test_create_repo () {
697 test "$#" = 1 ||
698 error "bug in the test script: not 1 parameter to test-create-repo"
699 repo="$1"
700 mkdir -p "$repo"
701 (
702 cd "$repo" || error "Cannot setup test environment"
703 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
704 error "cannot run git init -- have you built things yet?"
705 mv .git/hooks .git/hooks-disabled
706 ) || exit
707}
9ce415d9
JS
708
709# This function helps on symlink challenged file systems when it is not
710# important that the file system entry is a symbolic link.
711# Use test_ln_s_add instead of "ln -s x y && git add y" to add a
712# symbolic link entry y to the index.
713
714test_ln_s_add () {
715 if test_have_prereq SYMLINKS
716 then
717 ln -s "$1" "$2" &&
718 git update-index --add "$2"
719 else
720 printf '%s' "$1" >"$2" &&
721 ln_s_obj=$(git hash-object -w "$2") &&
722 git update-index --add --cacheinfo 120000 $ln_s_obj "$2"
723 fi
724}
4d715ac0 725
a0e0ec9f
JK
726perl () {
727 command "$PERL_PATH" "$@"
728}
a3a9cff0 729
83d842dc
JK
730# Is the value one of the various ways to spell a boolean true/false?
731test_normalize_bool () {
732 git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
733}
734
735# Given a variable $1, normalize the value of it to one of "true",
736# "false", or "auto" and store the result to it.
737#
738# test_tristate GIT_TEST_HTTPD
739#
740# A variable set to an empty string is set to 'false'.
741# A variable set to 'false' or 'auto' keeps its value.
742# Anything else is set to 'true'.
743# An unset variable defaults to 'auto'.
744#
745# The last rule is to allow people to set the variable to an empty
746# string and export it to decline testing the particular feature
747# for versions both before and after this change. We used to treat
748# both unset and empty variable as a signal for "do not test" and
749# took any non-empty string as "please test".
750
751test_tristate () {
752 if eval "test x\"\${$1+isset}\" = xisset"
753 then
754 # explicitly set
755 eval "
756 case \"\$$1\" in
757 '') $1=false ;;
758 auto) ;;
759 *) $1=\$(test_normalize_bool \$$1 || echo true) ;;
760 esac
761 "
762 else
763 eval "$1=auto"
764 fi
765}
766
767# Exit the test suite, either by skipping all remaining tests or by
768# exiting with an error. If "$1" is "auto", we then we assume we were
769# opportunistically trying to set up some tests and we skip. If it is
770# "true", then we report a failure.
771#
772# The error/skip message should be given by $2.
773#
774test_skip_or_die () {
775 case "$1" in
776 auto)
777 skip_all=$2
778 test_done
779 ;;
780 true)
781 error "$2"
782 ;;
783 *)
784 error "BUG: test tristate is '$1' (real error: $2)"
785 esac
786}
787
4d715ac0
JS
788# The following mingw_* functions obey POSIX shell syntax, but are actually
789# bash scripts, and are meant to be used only with bash on Windows.
790
791# A test_cmp function that treats LF and CRLF equal and avoids to fork
792# diff when possible.
793mingw_test_cmp () {
794 # Read text into shell variables and compare them. If the results
795 # are different, use regular diff to report the difference.
796 local test_cmp_a= test_cmp_b=
797
798 # When text came from stdin (one argument is '-') we must feed it
799 # to diff.
800 local stdin_for_diff=
801
802 # Since it is difficult to detect the difference between an
803 # empty input file and a failure to read the files, we go straight
804 # to diff if one of the inputs is empty.
805 if test -s "$1" && test -s "$2"
806 then
807 # regular case: both files non-empty
808 mingw_read_file_strip_cr_ test_cmp_a <"$1"
809 mingw_read_file_strip_cr_ test_cmp_b <"$2"
810 elif test -s "$1" && test "$2" = -
811 then
812 # read 2nd file from stdin
813 mingw_read_file_strip_cr_ test_cmp_a <"$1"
814 mingw_read_file_strip_cr_ test_cmp_b
815 stdin_for_diff='<<<"$test_cmp_b"'
816 elif test "$1" = - && test -s "$2"
817 then
818 # read 1st file from stdin
819 mingw_read_file_strip_cr_ test_cmp_a
820 mingw_read_file_strip_cr_ test_cmp_b <"$2"
821 stdin_for_diff='<<<"$test_cmp_a"'
822 fi
823 test -n "$test_cmp_a" &&
824 test -n "$test_cmp_b" &&
825 test "$test_cmp_a" = "$test_cmp_b" ||
826 eval "diff -u \"\$@\" $stdin_for_diff"
827}
828
829# $1 is the name of the shell variable to fill in
830mingw_read_file_strip_cr_ () {
831 # Read line-wise using LF as the line separator
832 # and use IFS to strip CR.
833 local line
834 while :
835 do
836 if IFS=$'\r' read -r -d $'\n' line
837 then
838 # good
839 line=$line$'\n'
840 else
841 # we get here at EOF, but also if the last line
842 # was not terminated by LF; in the latter case,
843 # some text was read
844 if test -z "$line"
845 then
846 # EOF, really
847 break
848 fi
849 fi
850 eval "$1=\$$1\$line"
851 done
852}